com.singularsys.jep.misc.nullwrapper.functions

## Class NullWrappedLazyLogical

- java.lang.Object
- - com.singularsys.jep.functions.PostfixMathCommand
  - - com.singularsys.jep.misc.nullwrapper.functions.NullWrappedLazyLogical

- All Implemented Interfaces:
    CallbackEvaluationI, NullWrappedFunctionI, PostfixMathCommandI, java.io.Serializable

      public class NullWrappedLazyLogical
      extends PostfixMathCommand
      implements CallbackEvaluationI, NullWrappedFunctionI

  Null wrapped versions of the LazyLogical functions. In version 3.5 the convention has been changed to behave like the MySQL logical operators.

  A OR B | True | False | null
  --- | --- | --- | ---
  True | True | True | True
  False | True | False | null
  null | True | null | null

  A AND B | True | False | null
  --- | --- | --- | ---
  True | True | False | null
  False | False | False | False
  null | null | False | null

  A | NOT A
  --- | ---
  True | False
  False | True
  null | null

  Since:
    3.4
  Version:
    3.5
  Author:
    Richard Morris
  See Also:
    `LazyLogical`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `allowNumbers`
    `static int` | `AND`
    `protected int` | `id` Represents which logical operator this is.
    `static int` | `OR`

    - ### Fields inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `curNumberOfParameters, name, NaN, numberOfParameters`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NullWrappedLazyLogical(int id_in)` Standard constructor, non zero Numbers will be treated as true and zero Numbers as false.
    `NullWrappedLazyLogical(int id_in, boolean disallowNumbers)` Constructor which restricts type of arguments.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `evaluate(Node node, Evaluator pv)` Performs some special evaluation on the node.
    `PostfixMathCommandI` | `getRoot()` Get to function which this function wraps.

    - ### Methods inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `asArray, asBool, asDouble, asInt, asLong, asStrictInt, asString, checkNumberOfParameters, getName, getNumberOfParameters, run, setCurNumberOfParameters, setName, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### AND

          public static final int AND

      See Also:
        Constant Field Values

    - #### OR

          public static final int OR

      See Also:
        Constant Field Values

    - #### id

          protected int id

      Represents which logical operator this is.

    - #### allowNumbers

          protected boolean allowNumbers

  - ### Constructor Detail

    - #### NullWrappedLazyLogical

          public NullWrappedLazyLogical(int id_in)

      Standard constructor, non zero Numbers will be treated as true and zero Numbers as false.
      Parameters:
        `id_in` - either of the constants AND or OR

    - #### NullWrappedLazyLogical

          public NullWrappedLazyLogical(int id_in,
                                        boolean disallowNumbers)

      Constructor which restricts type of arguments.
      Parameters:
        `id_in` -
        `disallowNumbers` - if true Number arguments will raise exceptions, otherwise as the Standard constructor.

  - ### Method Detail

    - #### getRoot

          public PostfixMathCommandI getRoot()

      Description copied from interface: `NullWrappedFunctionI`
      Get to function which this function wraps.
      Specified by:
        `getRoot` in interface `NullWrappedFunctionI`
      Returns:
        the root function, may be "this".

    - #### evaluate

          public java.lang.Object evaluate(Node node,
                                           Evaluator pv)
                                    throws EvaluationException

      Description copied from interface: `CallbackEvaluationI`
      Performs some special evaluation on the node. This method has the responsibility for evaluating the children of the node and it should generally call

           pv.eval(node.jjtGetChild(i))

      for each child. The SymbolTable is not passed as an argument. This is because it is better practice to get and set variable values by using node.getVar().setValue() rather that through the SymbolTable with requires a hashtable lookup.
      Specified by:
        `evaluate` in interface `CallbackEvaluationI`
      Parameters:
        `node` - The current node
        `pv` - The visitor, can be used evaluate the children
      Returns:
        the value after evaluation. This value will be passed to other functions higher up the node tree. The value can be any type including Double or Vector<Object>
      Throws:
        `EvaluationException` - if the calculation cannot be performed
      See Also:
        `Evaluator`

Copyright © 2018 Singular Systems http://www.singularsys.com/jep